#NoTrayIcon
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Outfile=SetFolDateFM.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Fileversion=0.3.1.5
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=p
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Array.au3>
#include <File.au3>
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <WinAPIEx.au3>
#include 'RFLTA.au3'

Global $bExecAll, $sFileDateType = 0, $bSort = 0, $bRecurse = False, $bDateLimit = False, $bIncFolders = False
Global $sInifile = StringLeft(@ScriptFullPath, StringLen(@ScriptFullPath) - 4) & '.ini'
Dim $aFolDateType[3]

$aTemp = $CmdLine
_IniThing(False)

Switch $aTemp[0]
	Case 0     ; No args, provide example DOpus config
		_DInstall()
	Case Else
		$bRunAndExit = False
		$k = _ArraySearch($aTemp, "/r")
		If $k > 0 Then
			_ArrayDelete($aTemp, $k)
			$aTemp[0] = UBound($aTemp) - 1
			$bRunAndExit = True
			$bExecAll = True
		EndIf
		FileChangeDir($aTemp[1])
		If Not $bRunAndExit Then _Options()
		For $i = 2 To $aTemp[0]
			If $bRecurse Then
				$aFolder = _RecFileListToArray($aTemp[$i], "*", 2, 1, 1) ; Folders only, Recurse, Sorted
				If @error <> 1 Then
					_ArrayReverse($aFolder, 1)  ; Reverse it so as to do lowest folder first
					For $j = 1 To $aFolder[0]
						_SetFileDate($aTemp[$i] & "\" & $aFolder[$j])
					Next
				EndIf
			EndIf
			_SetFileDate($aTemp[$i])
			If Not $bExecAll And ($i < $aTemp[0]) Then _Options()
		Next
EndSwitch
Exit

Func _SetFileDate($sFolder)
	Local $sFiletime, $sFilename, $aFiles
	If $bIncFolders Then
		$aFiles = _FileListToArray($sFolder, "*", 0)
	Else
		$aFiles = _FileListToArray($sFolder, "*", 1)
	EndIf
	If @error <> 4 And @error <> 1 Then
		For $i = 1 To $aFiles[0]
			$sFilename = $sFolder & "\" & $aFiles[$i]
			$sFiletime = FileGetTime($sFilename, $sFileDateType, 1)
			$sFilename = $sFiletime & "|" & $sFilename
			$aFiles[$i] = $sFilename
		Next
		_ArraySort($aFiles, $bSort, 1)

		$sFiletime = StringSplit($aFiles[1], "|")

		For $i = 0 To 2
			If $aFolDateType[$i] Then
				Switch $bDateLimit
					Case True
						If $sFiletime[1] > "19800101000000" Then FileSetTime($sFolder, $sFiletime[1], $i)
					Case False
						FileSetTime($sFolder, $sFiletime[1], $i)
				EndSwitch
			EndIf
		Next
	EndIf
EndFunc   ;==>_SetFileDate



Func _Options()
	Local $aPos = _GUIatMouse()
	#region ### START Koda GUI section ### Form=D:\My Documents\AutoIt\_Coding Snacks\SetFolDate\SetFolDate.kxf
	Local $Form = GUICreate("SetFolDate", 314, 191, $aPos[0], $aPos[1])

	Local $Group1 = GUICtrlCreateGroup("Set Folder Date", 16, 16, 94, 104)
	$Checkbox3 = GUICtrlCreateCheckbox("Modified", 24, 40, 70, 17)
	If $aFolDateType[0] Then GUICtrlSetState(-1, $GUI_CHECKED)
	$Checkbox4 = GUICtrlCreateCheckbox("Created", 24, 64, 70, 17)
	If $aFolDateType[1] Then GUICtrlSetState(-1, $GUI_CHECKED)
	$Checkbox5 = GUICtrlCreateCheckbox("Accessed", 24, 88, 70, 17)
	If $aFolDateType[2] Then GUICtrlSetState(-1, $GUI_CHECKED)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	Local $Group2 = GUICtrlCreateGroup("File Date", 204, 16, 94, 104)
	Local $Radio4 = GUICtrlCreateRadio("Modified", 212, 40, 70, 17)
	Local $Radio5 = GUICtrlCreateRadio("Created", 212, 64, 70, 17)
	Local $Radio6 = GUICtrlCreateRadio("Accessed", 212, 88, 70, 17)
	Switch $sFileDateType
		Case 0
			GUICtrlSetState($Radio4, $GUI_CHECKED)
		Case 1
			GUICtrlSetState($Radio5, $GUI_CHECKED)
		Case 2
			GUICtrlSetState($Radio6, $GUI_CHECKED)
	EndSwitch
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	Local $Group3 = GUICtrlCreateGroup("Using", 120, 16, 73, 82)
	Local $Radio7 = GUICtrlCreateRadio("Oldest", 128, 40, 65, 17)
	Local $Radio8 = GUICtrlCreateRadio("Newest", 128, 64, 65, 17)
	If $bSort = 1 Then
		GUICtrlSetState(-1, $GUI_CHECKED)
	Else
		GUICtrlSetState($Radio7, $GUI_CHECKED)
	EndIf
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	Local $Checkbox1 = GUICtrlCreateCheckbox("Recurse", 128, 128, 60, 17)
	GUICtrlSetTip(-1, "Recurse into sub-folders using settings")
	If $bRecurse Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $Checkbox2 = GUICtrlCreateCheckbox("Date Limit", 24, 128, 70, 17)
	GUICtrlSetTip(-1, "Only use dates later than 01-Jan-1980")
	If $bDateLimit Then GUICtrlSetState(-1, $GUI_CHECKED)
	Local $Checkbox6 = GUICtrlCreateCheckbox("Include folders", 212, 128, 89, 17)
	GUICtrlSetTip(-1, "Use folder dates as well as file dates")
	If $bIncFolders Then GUICtrlSetState(-1, $GUI_CHECKED)

	Local $Button1 = GUICtrlCreateButton("Execute", 216, 152, 75, 25)
	GUICtrlSetTip(-1, "Execute using chosen settings one folder at a time")
	Local $Button2 = GUICtrlCreateButton("Cancel", 24, 152, 75, 25)
	Local $Button3 = GUICtrlCreateButton("Exec ALL", 120, 152, 75, 25)
	GUICtrlSetTip(-1, "Execute using chosen settings on all selected folders")

	GUISetState(@SW_SHOW)
	#endregion ### END Koda GUI section ###

	While 1
		Local $nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $Button2
				Exit
			Case $Button1, $Button3
				$bExecAll = ($nMsg = $Button3)
				$aFolDateType[0] = (GUICtrlRead($Checkbox3) = $GUI_CHECKED) ;Modified
				$aFolDateType[1] = (GUICtrlRead($Checkbox4) = $GUI_CHECKED) ;Created
				$aFolDateType[2] = (GUICtrlRead($Checkbox5) = $GUI_CHECKED) ;Accessed
				Select
					Case GUICtrlRead($Radio4) = $GUI_CHECKED ;Modified
						$sFileDateType = 0
					Case GUICtrlRead($Radio5) = $GUI_CHECKED ;Created
						$sFileDateType = 1
					Case GUICtrlRead($Radio6) = $GUI_CHECKED ;Accessed
						$sFileDateType = 2
				EndSelect
				Select
					Case GUICtrlRead($Radio7) = $GUI_CHECKED ;Oldest
						$bSort = 0
					Case GUICtrlRead($Radio8) = $GUI_CHECKED ;Newest
						$bSort = 1
				EndSelect
				$bRecurse = (GUICtrlRead($Checkbox1) = $GUI_CHECKED)
				$bDateLimit = (GUICtrlRead($Checkbox2) = $GUI_CHECKED)
				$bIncFolders = (GUICtrlRead($Checkbox6) = $GUI_CHECKED)
				_IniThing(True)
				ExitLoop
		EndSwitch
	WEnd
	GUISetState(@SW_HIDE)
EndFunc   ;==>_Options

Func _DInstall()
	Local $temp = '<?xml version="1.0" encoding="UTF-8"?>' & @CRLF & '<usercommand backcol="none" hide_from_menu="no" textcol="none">' & @CRLF & '<label>Adjust_Timestamp</label>'
	$temp &= '<user_label>Adjust_Timestamp</user_label>' & @CRLF & '<icon1>#usercommand</icon1>' & @CRLF & '<function type="normal">' & @CRLF & '<instruction>@dirsonly</instruction>'
	$temp &= '<instruction>Go {ss}</instruction>' & @CRLF & '<instruction>&quot;' & @ScriptFullPath & '&quot; {ss} {allfile}</instruction>' & @CRLF & '</function>' & @CRLF & '</usercommand>'
	FileWrite(@DesktopDir & '\Adjust_Timestamp.ouc', $temp)
EndFunc   ;==>_DInstall

Func _GUIatMouse()
	Local $aMpos = MouseGetPos()
	Local $iDheight = @DesktopHeight
	If @DesktopWidth - $aMpos[0] < 290 Then $aMpos[0] = @DesktopWidth - 330
	If @DesktopHeight - $aMpos[1] < 170 Then $aMpos[1] = @DesktopHeight - 220
	Return $aMpos
EndFunc   ;==>_GUIatMouse

Func _IniThing($temp)
	If $temp Then
		IniWriteSection($sInifile, "General", "Recurse=" & $bRecurse & @LF & "Age=" & $bSort & @LF & "DateLimit=" & $bDateLimit & @LF & "IncFolders=" & $bIncFolders & @LF & "FileDate=" & $sFileDateType)
		IniWriteSection($sInifile, "Folder", "Modified=" & $aFolDateType[0] & @LF & "Created=" & $aFolDateType[1] & @LF & "Accessed=" & $aFolDateType[2])
	Else
		$bRecurse = (IniRead($sInifile, "General", "Recurse", "False") = "True")
		$bSort = IniRead($sInifile, "General", "Age", "1")
		$bDateLimit = (IniRead($sInifile, "General", "DateLimit", "False") = "True")
		$bIncFolders = (IniRead($sInifile, "General", "IncFolders", "False") = "True")
		$sFileDateType = IniRead($sInifile, "General", "FileDate", "0")
		$aFolDateType[0] = (IniRead($sInifile, "Folder", "Modified", "True") = "True")
		$aFolDateType[1] = (IniRead($sInifile, "Folder", "Created", "False") = "True")
		$aFolDateType[2] = (IniRead($sInifile, "Folder", "Accessed", "False") = "True")
	EndIf
EndFunc   ;==>_IniThing